/*
  a basic player
  Copyright (C) 1998  Martin Vogt

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation.

  For more information look at the file COPYRIGHT in this package

 */





#ifndef _PLAYER_H
#define _PLAYER_H


#include <qlayout.h>


#include <yafAmplifier/metaPlayer.h>
#include <devices/multicastDevice.h>

#include <deviceWidgets/guiVolumeDevice.h>
#include <deviceWidgets/guiSpectrumAnalyser.h>

#include "timerWidget.h"
#include "statusWidget.h"
#include "infoWidget.h"
#include "decoderWidget.h"
#include "volumeWidget.h"


#include <drag.h>
#include <kurl.h>

class KmpgPlayer : public QWidget , public MetaPlayer  {
  Q_OBJECT

  MulticastDevice* multicastDevice;

  GuiSpectrumAnalyser* guiSpectrumAnalyser;
  
  TimerWidget* timerWidget;
  StatusWidget* statusWidget;
  InfoWidget* infoWidget;
  GuiDecoder* decoderWidget;
  VolumeWidget* volumeWidget;

  KURL* currentUrl;

 public:
  KmpgPlayer( QWidget *parent=0, const char *name=0 );
  ~KmpgPlayer();

 public slots:
  int open(KURL* url);

  void setGenericStreamProducer(GenericStreamProducer* aDecoder);
  void addListener(NodeDevice* listener);

  // Called when files are droppen on the main window
  void onDrop( KDNDDropZone* );

  void volumeFilterActive(int active);

 protected:
  OutputDevice* getInternalDeviceTree();
  void buildGUI();

  QBoxLayout* topLayout;
  KDNDDropZone* dropZone;
};

#endif


  
