/*
  stores spectrum An. values, in order to have a delayed display
  Copyright (C) 1998  Martin Vogt;Philip VanBaren, 2 September 1993

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation.

  For more information look at the file COPYRIGHT in this package

 */



#include <widgetUtil/spectrumAnalyserQueue.h>


SpectrumAnalyserQueue::SpectrumAnalyserQueue(int bands) {
  int i;
  this->bands=bands;
  

  for(i=0;i<__MAX_SPAQ_ENTRIES;i++) {
    spaQueueArray[i]=new SPAQueueEntry();
    spaQueueArray[i]->valid=false;
    spaQueueArray[i]->startPtr=new int[bands];
  }
  readPos=0;
  freePos=0;
  fillgrade=0;
}


SpectrumAnalyserQueue::~SpectrumAnalyserQueue() {
  int i;

  for(i=0;i<__MAX_SPAQ_ENTRIES;i++) {
    delete spaQueueArray[i]->startPtr;
    delete spaQueueArray[i];
  }
}



int* SpectrumAnalyserQueue::getFreeEntry() {
  if (spaQueueArray[freePos]->valid==false) {
    return spaQueueArray[freePos]->startPtr;
  }
  return NULL;
}


void SpectrumAnalyserQueue::enqueue() {
  spaQueueArray[freePos]->valid=true;
  freePos++;
  fillgrade++;
  if (freePos == __MAX_SPAQ_ENTRIES) {
    freePos=0;
  }
}


void SpectrumAnalyserQueue::enqueue(int* target,int* src) {
  int i;

  for(i=0;i<bands;i++) {
    target[i]=src[i];
  }
  enqueue();
}
  
  

int* SpectrumAnalyserQueue::getNextEntry() {
  if (spaQueueArray[readPos]->valid==true) {
    return spaQueueArray[readPos]->startPtr;
  }
  return NULL; 
}


void SpectrumAnalyserQueue::dequeue() {
  spaQueueArray[readPos]->valid=false;

  readPos++;
  fillgrade--;
  if (readPos == __MAX_SPAQ_ENTRIES) {
    readPos=0;
  }  
}

int SpectrumAnalyserQueue::getFillgrade() {
  return fillgrade;
}

int SpectrumAnalyserQueue::getBands() {
  return bands;
}

