/*
  wrapper class for a toolkit signal mechanism
  Copyright (C) 1998  Martin Vogt

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation.

  For more information look at the file COPYRIGHT in this package

 */



#include <signal/qt/notifyMainThread.h>



NotifyMainThread::NotifyMainThread(NotifyMainThreadClient* client) {
  this->client=client;
  delivered=true;

  pthread_mutex_init(&deliverMut,NULL);
  pthread_cond_init(&deliverCond,NULL);
  
  ::pipe(fd);
  sn=new QSocketNotifier( fd[0], QSocketNotifier::Read, NULL );
  QObject::connect(sn,SIGNAL(activated(int)),this,SLOT(clientNotify()));
}


NotifyMainThread::~NotifyMainThread() {
}


void NotifyMainThread::sendNotify(char msgId) {
  pthread_mutex_lock(&deliverMut);
  while (delivered == false) {
    pthread_cond_wait(&deliverCond,&deliverMut);
  }
  write(fd[1],&msgId,1);
  delivered=false;
  pthread_mutex_unlock(&deliverMut);
}


void NotifyMainThread::clientNotify() {
  pthread_mutex_lock(&deliverMut);
  char dummy;
  ::read(fd[0],&dummy,1);
  msgId=dummy;
  client->processNotify(msgId);
  delivered=true;
  pthread_cond_signal(&deliverCond);
  pthread_mutex_unlock(&deliverMut);
 
}

